;;; 20060326_2ch-dat-to-html.l
;;; Ver.0.4.2.20180615
;;; License: CC0
;;; 2006-03-26, 2018-06-15
;;; http://purl.com/dkcc/shed/2ch-dat-to-html.html

#|
next:
img file name collision => not necessary

ok:
embed images
2ch Be
"a bone"
error handling
  cannot make output file
  except dat
outdir/srcdir
ampersand
file list
make anchor from url
Shitaraba dat format
|#

;;; global

(provide "2ch-dat-to-html")     ; added, Ver.0.4.2.20180615

(defun replace-regexp-whole (regexp replacement &optional case-fold) ; updated from kmpublic, Ver.0.4.2.20180615
  "replace-regexp for whole buffer."
  (interactive "*sReplace regexp: \nswith: ")
  (save-excursion
    (goto-char (point-min))
    (replace-regexp (compile-regexp regexp case-fold) replacement t)))

;;; template - structure

(defvar *2ch-dat-to-html-head*  ; make "template - structure" user-changeable, Ver.0.4.2.20180609
  "<!DOCTYPE html PUBLIC \"ISO/IEC 15445:2000//DTD HyperText Markup Language//EN\">
<html lang=\"ja\">
<head>
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">
	<link rel=\"stylesheet\" type=\"text/css\" title=\"2ch-style\" href=\"bbs2ch.css\">"
  "HTML header (except title and </head>) to be inserted in 2ch-dat-to-html.")
(defvar *2ch-dat-to-html-head-xhtml11*
  "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">
<head>
	<link rel=\"stylesheet\" type=\"text/css\" title=\"2ch-style\" href=\"bbs2ch.css\" />"
  "XHTML 1.1 header (except title and </head>) to be inserted in 2ch-dat-to-xhtml11.")
(defun 2ch-dat-to-html-head-body (xhtml title)
  (if xhtml
      (insert *2ch-dat-to-html-head-xhtml11*)
    (insert *2ch-dat-to-html-head*))
  ;(msgbox-variables title)      ; debug
  #|(with-output-to-selected-buffer
   (format t "
	<title>~A</title>
</head>
<body>
<h1>~A</h1>
<dl class=\"bbs\">
" title title)))|#
  (insert "
	<title>" title "</title>
</head>
<body>
<h1>" title "</h1>
<dl class=\"bbs\">
"))

(defun 2ch-dat-to-html-footer (xhtml title)
  (insert "</dl>
</body>
</html>
<!-- Converted by 2ch-dat-to-html, Ver.0.4.2.20180615, http://purl.com/dkcc/shed/2ch-dat-to-html.html -->"))

;;; template - inline

(defvar *2ch-dat-to-html-uri-filename* "-a-zA-Z0-9_~\\.@\\?&=;\\+(),'\\$!\\*:%|" ; changed defconstant to defvar to be changeable, Ver.0.4.2.20180609
  "Characters of regexp for detecting URIs in 2ch-dat-to-html.") ; documentation is added, Ver.0.4.2.20180609
(defvar *2ch-dat-to-html-scan-a* (concat "\\(h?\\(ttps?://[" *2ch-dat-to-html-uri-filename* "/#]+\\)\\)")
  "Regexp for detecting hyperlinks in 2ch-dat-to-html.") ; https added, Ver.0.4.2.20180609
(defvar *2ch-dat-to-html-scan-img* (concat "\\(h?\\(ttps?://[" *2ch-dat-to-html-uri-filename* "/]*/\\([" *2ch-dat-to-html-uri-filename* "]*?\\.\\(bmp\\|gif\\|jpe\\|jpe?g\\|png\\|svgz?\\|tiff?\\)\\)\\)\\)")
  "Regexp for detecting images in 2ch-dat-to-html.")

(defun 2ch-dat-to-html-embed-images (&optional xhtml srcdir &aux (xml-nestc (if xhtml " /" "")))
  (replace-regexp-whole
   *2ch-dat-to-html-scan-img*
   (concat "<img alt=\"\\1\" src=\""
           (if srcdir
               (concat srcdir "\\3")
             "h\\2")
           "\"" xml-nestc ">")
   t))

(defun 2ch-dat-to-html-markup-a (&optional xhtml)
  (replace-regexp-whole *2ch-dat-to-html-scan-a* "<a href=\"h\\2\">\\1</a>" t))

(defun 2ch-dat-to-html-markup-a-with-img (&optional xhtml srcdir &key a-img &aux (xml-nestc (if xhtml " /" "")))
  (2ch-dat-to-html-markup-a xhtml)
  (replace-regexp-whole
   (concat "<a href=\"" *2ch-dat-to-html-scan-img* "\">" *2ch-dat-to-html-scan-img* "</a>")
   (if a-img
       "<a href=\"\\1\"><img alt=\"\\2\" src=\"\\1\"></a>"
     (concat "<img alt=\"\\5\" src=\""
             (if srcdir
                 (concat srcdir "\\3")
               "h\\2")
             "\"" xml-nestc ">"))))

;;; core

(defun 2ch-dat-to-html-1 (fi &optional xhtml img (a t) &key outdir srcdir a-img &aux (filename fi) title) ; &aux (bi (selected-buffer)) deleted, shitaraba case added, Ver.0.4.2.20180615
  "2ch-dat-to-html-1 converts one 2ch dat file into ISO-HTML or XHTML 1.1, can also embed images."
  ;  (interactive "f2ch dat: \nSxhtml: \nSimg: \nSa: ")
  ; input (file)
  #|(with-open-file (fi filename :direction :input)
(if (string-matchp (compile-regexp "^\\(.*?\\)\\(</b>\\(.+\\)<b>\\(.*\\)\\)?<>\\(.*\\)<>\\(.+\\)<>\\(.+\\)<>\\(.+?\\)\\(?:<>\\)?$") (read-line fi))
    (setq title (match-string 8))
  (error "may not 2ch dat file: \"~A\"" filename)))|#
  (let ((regexp-first-line (compile-regexp "^\\(?:\\([0-9]+\\)<>\\)?\\(.*?\\)\\(</b>\\(.+\\)<b>\\(.*\\)\\)?<>\\(.*\\)<>\\(.+\\)<>\\(.+\\)<>\\(.+?\\)\\(?:<>\\)?$")) ;  common regexp is set for normal dat and shitaraba dat
        (regexp-other-line (compile-regexp "^\\(?:\\([0-9]+\\)<>\\)?\\(.*?\\)\\(</b>\\(.+\\)<b>\\(.*\\)\\)?<>\\(.*\\)<>\\(.+\\)<>\\(.+?\\)<>.*?\\(?:<>\\)?$"))
        (already-opened-p (find-name-buffer (file-namestring filename))))
    ;(msgbox-variables filename already-opened-p) ; debug
    (save-excursion
      (find-file filename) ; find-file is used instead of insert to prevent garble, Ver.0.4.2.20180615
      (when already-opened-p (goto-char (point-min)))
      (if (scan-buffer regexp-first-line)
          (setq title (match-string 9))
        (error "may not 2ch dat file: \"~A\"" filename))
      (unless already-opened-p (delete-buffer (selected-buffer))))
    ;(msgbox "~{~A\n~}" (list (match-string 1) (match-string 2) (match-string 3) (match-string 4) (match-string 5) (match-string 6) (match-string 7) (match-string 8) (match-string 9))) ; debug
    ;(msgbox-variables title)      ; debug
    ; output (file)
    (string-matchp (compile-regexp "\\(.*\\).dat$") filename)
    (setq filename (concat (if (match-string 1) (match-string 1) filename) "." (when xhtml "x") "html"))
    (when outdir
      (setq filename (concat outdir "/" (file-namestring filename))))
    ;    (msgbox "~A" filename)
    (handler-case
     (long-operation
      (with-open-file (fo filename :direction :output))
      ; output (buffer)
      (switch-to-buffer "*dat2html*")
      (make-local-variable 'need-not-save)
      (setq need-not-save t)
      (erase-buffer (selected-buffer))
      (insert-file fi)
      ; ampersand
      (goto-char (point-min))
      (while (scan-buffer (compile-regexp "&\\(.*?;\\)?") :no-dup t)
        (let ((name (match-string 1)))
          (unless (or (string= name "lt;") (string= name "gt;") (string= name "nbsp;"))
            (replace-match "&amp;\\1")
            (backward-char))))
      ; a
      (replace-regexp-whole " target=\"_blank\">" ">")
      (goto-char (point-min))
      (while (scan-buffer (compile-regexp "<a href=\"\\(.+?\\)\""))
        (let ((fragment (car (split-string (car (last (split-string (match-string 1) "/"))) "-"))))
          (replace-match (concat "<a href=\"#N" fragment "\""))))
      (replace-regexp-whole "[^\\(&gt;\\)]\\(&gt;\\([0-9]+\\)\\(-[0-9]+\\)?\\)" "<a href=\"#N\\2\">\\1</a>")
      ; img, a
      (if a
          (if img
              (2ch-dat-to-html-markup-a-with-img xhtml srcdir :a-img a-img)
            (2ch-dat-to-html-markup-a xhtml))
        (when img (2ch-dat-to-html-embed-images xhtml srcdir)))
      ; xhtml peculiar
      (when xhtml
        (replace-regexp-whole "<br>" "<br />" t))
      ; dt, dd
      (goto-char (point-min))
      (let ((scan-buffer-result (scan-buffer regexp-first-line))) ; first line and other lines are separated, Ver.0.4.2.20180615
        (while scan-buffer-result
          ;(msgbox "~{~A\n~}" (list (match-string 1) (match-string 2) (match-string 3) (match-string 4) (match-string 5) (match-string 6) (match-string 7) (match-string 8) (match-string 9))) ; debug
          (let ((line (if (match-string 1) ; shitaraba dat has his own number
                          (match-string 1)
                        (format nil "~D" (current-line-number))))
                (name-latter (match-string 5)))
            (replace-match
             ;         (concat "<dt id=\"N" line "\">" line " F<em class=\"name\"><strong>\\2</strong>\\4"
             (concat "<dt id=\"N" line "\">" line " F<em class=\"name\">"
                     (when (string/= (match-string 2) "") "<strong>\\2</strong>") ; prevent <strong><strong>, Ver.0.4.2.20180609
                     "\\4"
                     (when (and name-latter (string/= name-latter "")) "<strong>\\5</strong>")
                     "</em>[\\6]F\\7</dt><dd>\\8</dd>")))
          (setq scan-buffer-result (scan-buffer regexp-other-line)))
        ; structure
        (goto-char (point-min))
        (2ch-dat-to-html-head-body xhtml title)
        (goto-char (point-max))
        (2ch-dat-to-html-footer xhtml title)
        ; finish
        (write-file filename)
        (delete-buffer (selected-buffer))
        (message "outputted to \"~A\"" filename)))
     (file-error (c) (error "cannot make output file: \"~A\"" filename)))))
#|
;;; regexp test
(prog1
    (string-matchp (compile-regexp "^\\(.*?\\)\\(</b>\\(.+\\)<b>\\(.*\\)\\)?<>\\(.*\\)<>\\(.+\\)<>\\(.+\\)<>.*$")
                   "")          ; string to be tested
  (for (i 0 9)
       (format t "~D: ~A\n" i (match-string i))))
|#

;;; application

(defmacro 2ch-dat-to-html-application (fname docstr &optional xhtml img (a t))
  `(defun ,fname (fi-list)
     ,docstr
     (interactive "l2ch dat files: ")
     (unless (listp fi-list) (setq fi-list (list fi-list))) ; fi-list becomes string if one file is chosen from minibuffer, added Ver.0.4.2.20180609
     (mapcar #'(lambda (fi) (2ch-dat-to-html-1 fi ,xhtml ,img ,a)) fi-list)
     (message "done.")))

(defmacro 2ch-dat-to-html-application-img (fname docstr &optional xhtml (img t) (a t))
  `(defun ,fname (fi-list &key srcdir)
     ,docstr
     (interactive "l2ch dat files: ")
     (unless (listp fi-list) (setq fi-list (list fi-list)))
     (when (yes-or-no-p "change SrcDir?")
       (setq srcdir (read-string "SrcDir: ")))
     (mapcar #'(lambda (fi) (2ch-dat-to-html-1 fi ,xhtml ,img ,a :srcdir srcdir)) fi-list)
     (message "done.")))

(defmacro 2ch-dat-to-html-application-manual (fname docstr &optional xhtml)
  `(defun ,fname (fi-list &optional img a &key outdir srcdir a-img)
     ,docstr
     (interactive "l2ch dat files: ")
     (unless (listp fi-list) (setq fi-list (list fi-list)))
     (setq outdir (read-directory-name "OutDir: "))
     (when (setq img (yes-or-no-p "embed images?"))
       (when (yes-or-no-p "change SrcDir?")
         (setq srcdir (read-string "SrcDir: "))))
     (when (setq a (yes-or-no-p "make url anchor?"))
       (when img
         (setq a-img (yes-or-no-p "make url anchor even if it is an embedded image?"))))
     (mapcar #'(lambda (fi) (2ch-dat-to-html-1 fi ,xhtml img a :outdir outdir :srcdir srcdir :a-img a-img)) fi-list)
     (message "done.")))

(2ch-dat-to-html-application 2ch-dat-to-html "2ch-dat-to-html converts 2ch dat files into ISO-HTML.")
(2ch-dat-to-html-application 2ch-dat-to-xhtml11 "2ch-dat-to-xhtml11 converts 2ch dat files into XHTML 1.1." t)

(2ch-dat-to-html-application-img 2ch-dat-to-html-img "2ch-dat-to-html-img converts 2ch dat files into ISO-HTML, and also embed images.")
(2ch-dat-to-html-application-img 2ch-dat-to-xhtml11-img "2ch-dat-to-xhtml11-img converts 2ch dat files into XHTML 1.1, and also embed images." t)

(2ch-dat-to-html-application-manual 2ch-dat-to-html-manual "Maunal mode for 2ch-dat-to-html.")
(2ch-dat-to-html-application-manual 2ch-dat-to-xhtml11-manual "Maunal mode for 2ch-dat-to-xhtml11." t)

;;; added Ver.0.4.2.20180609
(defvar *2ch-dat-to-html-selected-buffer-mode* "html"
  "Selected mode for 2ch-dat-to-html-selected-buffer. Available: html, xhtml11, html-img, xhtml11-img, html-manual, xhtml11-manual.")
(defun 2ch-dat-to-html-selected-buffer (&optional (mode *2ch-dat-to-html-selected-buffer-mode*))
  "Apply 2ch-dat-to-html (or other mode) to selected-buffer."
  (interactive)
  (funcall (intern (concat "2ch-dat-to-" mode)) (get-buffer-file-name (selected-buffer))))

;(describe-function '2ch-dat-to-html-1)
